from Classes.GeneralComputations import GeneralComputations as gc
import pandas as pd
import numpy as np
import math
from PyQt5 import QtCore
import timeit

class DataFrameForBigWindow():
    @staticmethod
    def createDataFrame(incomeDataFrame, wasOpened, incomeprogress=None):
        cmpt = gc(incomeDataFrame)
        minindex, indlist = cmpt.getminindividualcolumnindex()
        headers = list()
        headers.append(incomeDataFrame.columns.values[0])
        listvalues = []

        if wasOpened == 1:
            for i in range(1, len(incomeDataFrame.columns.values)):
                headers.append(incomeDataFrame.columns.values[i] + " E(S)")
            counter_dependent= 0
            processcounter = incomeDataFrame.shape[0]
            for i in range(0, incomeDataFrame.shape[0]):
                #print("i = ",i)
                listvalues.append([])
                listvalues[i].append(incomeDataFrame.iloc[i][0])
                for col in range(1, incomeDataFrame.shape[1]):
                    if col == minindex:
                        listvalues[i].append(incomeDataFrame.iloc[i][col])
                    else:
                        if incomeDataFrame.iloc[i][col] != 0:
                            result = cmpt.getrarevalue(indlist[minindex - 1], indlist[col - 1], incomeDataFrame.iloc[i][col])
                            listvalues[i].append(round(result, 5))
                        else:
                            listvalues[i].append(0)
                counter_dependent += 1
                if incomeprogress != None:
                    incomeprogress.setValue(int(((counter_dependent + 1) / processcounter) * 400))
                    QtCore.QCoreApplication.processEvents()

            # write to sum column data on end row
            listvalues.append([])
            listvalues[incomeDataFrame.shape[0]].append("Toplam")

            for col in range(1, incomeDataFrame.shape[1]):
                if col == minindex:
                    listvalues[incomeDataFrame.shape[0]].append(cmpt.getcountcolumnforindex(minindex, list(incomeDataFrame.columns.values)))
                else:
                    listvalues[incomeDataFrame.shape[0]].append(
                        round(sum([row[col] for row in listvalues if len(row) >= incomeDataFrame.shape[1]]), 5))

            #write to number of individuals data on end row
            listvalues.append([])
            listvalues[len(listvalues) -1].append("Toplam Birey Sayısı (N)")
            listvalues[len(listvalues) - 1].extend(indlist)
            return pd.DataFrame(listvalues, columns=headers)


        elif wasOpened == 2:
            start = timeit.default_timer()
            for i in range(1, len(incomeDataFrame.columns.values)):
                headers.append(incomeDataFrame.columns.values[i]+ ' E(Sn)')
                headers.append(incomeDataFrame.columns.values[i] + " σ(Sn)")
            maxlistvalue = max(indlist)
            sumofresult = 0
            colcount = ((incomeDataFrame.shape[1] -1) * 2) + 1
            deneme = np.zeros((maxlistvalue + 1, colcount))

            counter = 0
            processcounter = incomeDataFrame.shape[1]
            deneme[0][0] = 1
            for col in range(1, incomeDataFrame.shape[1]):
                nonzerovalues = cmpt.getnonezerocolumnvalues(col)
                nvalue = indlist[col -1]
                deneme[0][counter * 2 +1] = 1
                deneme[0][counter * 2 + 2] = 0
                for n in range(2, nvalue + 1):
                    deneme[n -1][0] = n
                    for row in range(0, len(nonzerovalues)):
                        resultE = cmpt.getrarevalue(n, nvalue, nonzerovalues[row])
                        sumofresult += resultE
                    if n == nvalue:
                        deneme[n - 1][counter * 2 +1] = round(sumofresult)
                        deneme[n - 1][counter * 2 + 2] = 0
                    else:
                        deneme[n - 1][counter * 2 + 1] = round(sumofresult,5)
                        deneme[n - 1][counter * 2 + 2] = round(cmpt.calcvariance(col, n, indlist, nonzerovalues), 6)
                    sumofresult = 0


                counter += 1

                if incomeprogress  is not None:
                    incomeprogress.setValue(int(((counter + 1) / processcounter) * 400))
                    QtCore.QCoreApplication.processEvents()

            stop = timeit.default_timer()
            print('Time: ', stop - start)

            return pd.DataFrame(deneme, columns=headers)

